' FFName=Koordinaten in Zwischenablage
'* kopiert Koordinaten aus dem aktuellen Bilde in die Zwischenablage, zur Verwendung mit dem Skript "Koordinaten zuweisen"
' ** KGsoft (Andreas Kleingnther)  
'Version 1.0 vom 06.08.2016

Option Explicit
Dim Pfad, Dateiname
Dim Breite, Laenge
Dim BreiteGeo, LaengeGeo

Pfad = FF_GetParam
Dateiname = Right(Pfad, Len (Pfad) - InStrRev(Pfad, "\",-1, 1))
FF_LoadExif (Pfad)
Breite = FF_GetExifTag("Latitude")
Laenge = FF_GetExifTag("Longitude")

if Len(Breite) > 0 Then									' nur wenn Geodaten vorhanden sind
	BreiteGeo = grad2decimal(Breite)
	LaengeGeo = grad2decimal (Laenge)
	FF_TextToClipboard BreiteGeo & "," & LaengeGeo
	Msgbox "Die Koordinaten " & Breite & ", " & Laenge & " wurden in die Zwischenablage kopiert." & vbNewLine & vbNewLine & "Die Daten knnen jetzt im Skript 'Koordinaten zuweisen' verwendet werden (Option GoogleMaps)", 64, "Koordinaten in die Zwischenablage"
Else
	Msgbox "Die Datei " & Dateiname & " enthlt keine Koordinaten.", 48, "Koordinaten in die Zwischenablage"
End If

'********************************************
'* grad2decimal wandelt  ' " in dezimal
'********************************************
function grad2decimal(ByVal p_Str)
	dim l_Richtung
	dim l_Pos
	dim l_Wert

	if p_Str<>"" then
		p_Str=replace(p_Str,".",",",1)
		l_Richtung=left(p_Str,1)
		p_Str=ltrim(right(p_Str,len(p_Str)-1))
		l_Pos=instr(p_Str,"")
		'msgbox l_Wert
		l_Wert=1.0*(left(p_Str,l_Pos-1))
		p_Str=ltrim(right(p_Str,len(p_Str)-l_Pos))
		l_Pos=instr(p_Str,"'")
		l_Wert=l_Wert + (left(p_Str,l_Pos-1))/60
		p_Str=ltrim(right(p_Str,len(p_Str)-l_Pos))
		l_Pos=instr(p_Str,"""")
		l_Wert=l_Wert + (left(p_Str,l_Pos-1))/3600
		Select Case l_Richtung
			Case "s", "S", "w", "W"
				grad2decimal="-" & replace(FormatNumber(l_Wert,6),",",".",1)
			case Else
				grad2decimal=replace(FormatNumber(l_Wert,6),",",".",1)
		End Select
	else
		grad2decimal=""
	end if
end function
