' FFSubmenu=GPS
' FFName=Koordinaten zuweisen
' bernimmt per Zwischenablage die Geo-Koordinaten von GMapCatcher
' und weist sie dem ersten in der CA markierten Bild zu
' ** KGsoft (Andreas Kleingnther) 
' Version 0.8 vom 12.07.2012	erste ffentliche Version
' Version 0.9 vom 13.07.2012	Fehlerkorrektur, Erfolgskontrolle verbessert
' Version 1.0 vom 09.09.2012	bernahme aus Google Maps
' Version 2.0 vom 04.08.2015	Anpassung an neu eGoogle Maps, verschiedene Bildquellen 
' Version 2.1 vom 16.08.2015	Koordinaten ber http://www.pkh-fix.de/geokoordinaten.html
' 		s. dazu http://gmaps-samples.googlecode.com/svn/trunk/geocoder/singlegeocode.html       
' 		auch nutzbar http://www.media-arts.de/systemhaus/spezielle-menue-s/globales-menue/tools/google-maps-koordinaten.html
' Version 2.2 vom 04.08.2016	Koordinaten auch von OpenStreetMaps, Erfolgskontrolle berarbeitet
' Version 2.3 vom 22.09.2016	auch Bild auf Arbeitsflche, nachtrgliche nderungen der Bildauswahl wird geprft

Option Explicit
const Version = "V 2.3"
Const RegSchluessel = "Koordinatenzuweisen"		' Registryschlssel
REM Const GoogleMapsSeite = "http://www.pkh-fix.de/geokoordinaten.html"
Const GoogleMapsSeite = "https://www.google.de/maps"
Const OSMSeite = "http://www.openstreetmap.org/"
Dim Taste
Dim TypQuelle
Dim ZAblage, Ablageteil
Dim Latitude_dez, Latitude_geo		' Breite
Dim Longitude_dez, Longitude_geo	' Lnge
'Dim ListeBilder					' Array mit den Bildern, Index startet bei 0
Dim AnzahlBilder				
Dim ListeBilder
Dim Bild
Dim i
Dim Suchmuster
Dim Erfolgsflag, Erfolg_ja, Erfolg_nein
Dim WshShell, Aufruf
Set WSHShell = CreateObject("WScript.Shell")

Call Dialogaufbau
Call Main

Sub Main
	AnzahlBilder = -1
	FF_SetDialogTimer "Koordinaten zuweisen", 100       ' fr erste Anzeige der Bilderanzahl nach Start
	Do
		Taste = FF_ShowDialog("Koordinaten zuweisen")
		Select Case Taste
			Case "TIMER"								' Vorbelegung markierte Bilder in Computeransicht
				TypQuelle = 1
				AnzahlBilder = AnzBilder(TypQuelle)
				FF_SetControl "Koordinaten zuweisen" ,"|", AnzahlBilder
				FF_SetDialogTimer "Koordinaten zuweisen", 0
			Case "combo_quelle"
				Select Case FF_GetControl ("Koordinaten zuweisen", "combo_quelle")
				Case "Computer-Ansicht, alle Bilder"
					TypQuelle = 0
					AnzahlBilder = AnzBilder(TypQuelle)
					FF_SetControl "Koordinaten zuweisen" ,"|", AnzahlBilder
				Case "Computer-Ansicht, markierte Bilder"
					TypQuelle = 1
					AnzahlBilder = AnzBilder(TypQuelle)
					FF_SetControl "Koordinaten zuweisen" ,"|", AnzahlBilder
				Case "Bilderliste, alle Bilder"
					TypQuelle = 2
					'Call Bilder_einlesen
					AnzahlBilder = AnzBilder(TypQuelle)
					FF_SetControl "Koordinaten zuweisen" ,"|", AnzahlBilder
				Case "Bilderliste, markierte Bilder"
					TypQuelle = 3
					AnzahlBilder = AnzBilder(TypQuelle)
					FF_SetControl "Koordinaten zuweisen" ,"|", AnzahlBilder
				Case "geladenes Bild"
					AnzahlBilder = -2 						' -2 = Flag fr Bild auf Arbeitsbereich
					'msgbox FF_GetImageName(-1)
					FF_SetControl "Koordinaten zuweisen" ,"|", ""
			End Select
			Case "quelle1_bool"
				if FF_GetControl("Koordinaten zuweisen", "quelle1_bool") = "1" Then
					FF_SetControl "Koordinaten zuweisen", "quelle2_bool", "0"
					FF_SetControl "Koordinaten zuweisen", "quelle3_bool", "0"
				End If
			Case "quelle2_bool"
				if FF_GetControl("Koordinaten zuweisen", "quelle2_bool") = "1" Then
					FF_SetControl "Koordinaten zuweisen", "quelle1_bool", "0"
					FF_SetControl "Koordinaten zuweisen", "quelle3_bool", "0"
				End If
			Case "quelle3_bool"
				if FF_GetControl("Koordinaten zuweisen", "quelle3_bool") = "1" Then
					FF_SetControl "Koordinaten zuweisen", "quelle1_bool", "0"
					FF_SetControl "Koordinaten zuweisen", "quelle2_bool", "0"
				End If	
			Case "->"
				WSHShell.Run GoogleMapsSeite
			Case "|->"
				WSHShell.Run OSMSeite
			Case "Koordinaten aus der Zwischenablage" & vbNewLine & "den Bildern zuweisen"
				'*** Kontrolle, ob Markierung zwischenzeitlich gendert wurde
				if AnzahlBilder > -2 Then					' nicht Bild der Arbeitsflcbe gewhlt
					if AnzahlBilder <> AnzBilder(TypQuelle) Then
						AnzahlBilder = AnzBilder(TypQuelle)
						FF_SetControl "Koordinaten zuweisen" ,"|", AnzahlBilder
						Msgbox "Die Bildauswahl wurde zwischenzeitlich gendert und jetzt hier aktualisiert.", 64, "Koordinaten zuweisen"
					end If
				end if
				
				ZAblage = FF_TextFromClipboard()
				REM ZAblage = "50.7102169, 12.473372499999982" 							' fr Testzwecke
				If FF_GetControl("Koordinaten zuweisen", "quelle2_bool") = "1" Then		' von GoogleMaps
					'* fr http://www.pkh-fix.de/geokoordinaten.html
					zablage = Replace(zablage, vbNewLine, "")	' fhrenden Zeilenumbruch entfernen
					If Daten_gueltig(ZAblage) = True Then
						Ablageteil = Split (ZAblage, ",")
						Latitude_dez = Ablageteil(0)
						Longitude_dez = Ablageteil(1)
						'* fr http://www.media-arts.de/systemhaus/spezielle-menue-s/globales-menue/tools/google-maps-koordinaten.html
						REM Ablageteil = Split (ZAblage,vbNewLine)
						REM Latitude_dez = Mid(Ablageteil(0), 14, 25)
						REM Longitude_dez = Mid(Ablageteil(1), 13, 25)
						Call Zuweisung
					end if
				ElseIf FF_GetControl("Koordinaten zuweisen", "quelle3_bool") = "1" Then	' von OSM
					'* fr http://www.openstreetmap.org
					' Teilstring zwischen Doppelpunkt und Fragezeichen
					ZAblage = MidString(ZAblage, ":","?")
					If Daten_gueltig(ZAblage) = True Then					
						Ablageteil = Split (ZAblage, ",")
						Latitude_dez = Ablageteil(0)
						Longitude_dez = Ablageteil(1)
						Call Zuweisung
					end If
				ElseIf FF_GetControl("Koordinaten zuweisen", "quelle1_bool") = "1" Then	' von GMapCatcher
					If Daten_gueltig(ZAblage) = True Then
						' Format: Latitude=50.283197, Longitude=12.238426
						Latitude_dez = left(ZAblage, InStr(ZAblage,",")-1)
						Latitude_dez = Mid(Latitude_dez, InStr(Latitude_dez,"=")+1) 	' "Latitude=" abschneiden
						Longitude_dez = Mid(ZAblage, InStr(ZAblage,",")+1)
						Longitude_dez = Mid(Longitude_dez, InStr(Longitude_dez,"=")+1) 	' "Longitude=" abschneiden
						Call Zuweisung
					end If
				End If
			Case "Schlieen", "CANCEL"
				FF_WriteProfile RegSchluessel,"GMapCatcher", FF_GetControl("Koordinaten zuweisen", "quelle1_bool")
				FF_WriteProfile RegSchluessel,"GoogleMaps", FF_GetControl("Koordinaten zuweisen", "quelle2_bool")
				FF_WriteProfile RegSchluessel,"OSM", FF_GetControl("Koordinaten zuweisen", "quelle3_bool")
				Exit Do
			Case "?"
				WSHShell.Run Chr(34) & FF_GetFFPathEx(2) & "\Koordinatenzuweisen\Koordinaten_zuweisen.pdf" & Chr(34)
				REM Call Hilfetext				
		End Select
	Loop
End Sub

Function AnzBilder (TypQuelle)
	'Bilder in Array eintragen
	'AnzahlBilder = -1
	ListeBilder = split(FF_GetSelection(TypQuelle), vbNewLine)	
	AnzBilder = ubound(ListeBilder) + 1
End Function

Function Daten_gueltig (ByVal Daten)
	Daten_gueltig = False
	If AnzahlBilder = -1 Then
		MsgBox "Es wurden keine Bild ausgewhlt.", 48
		Exit Function
	End If
	If FF_GetControl("Koordinaten zuweisen", "quelle2_bool") = "1" or FF_GetControl("Koordinaten zuweisen", "quelle3_bool") = "1" Then		' von GoogleMaps oder OSM
		Suchmuster = "^(\+|-)?[0-9]+[.][0-9]*\s*[,]\s*(\+|-)?[0-9]+[.][0-9]+$"    
		' optionales Vorzeichen / beliebieg Ziffern / Punkt /beliebige Ziffern / Komma, opional mit Leerzeichen / optionales Vorzeichen / beliebieg Ziffern / Punkt /beliebige Ziffern
		If SearchRegAusdr (Daten, Suchmuster, False) = True Then
 		REM if InStr(Daten,".") = 2 and InStr(Daten,",") = 1 Then	' geprft wird auf genau zwei Punkte und ein Komma
			Daten_gueltig = True
		Else
			MsgBox "Die Zwischenablage enthlt keine gltigen Koordinaten.", 48
			exit Function
		end If
	end If
	If FF_GetControl("Koordinaten zuweisen", "quelle1_bool") = "1" Then	' von GMapCatcher
		if InStr(Daten, "Latitude") > 0 and InStr(Daten, "Longitude") > 0 Then
			Daten_gueltig = True
		Else
			MsgBox "Die Zwischenablage enthlt keine gltigen Koordinaten.", 48
			exit Function
		end If
	End If
End Function

Sub Zuweisung
	FF_SetControl "Koordinaten zuweisen","ergeb_edit", ""
	FF_SetControl "Koordinaten zuweisen","laenge_dez", Left(Longitude_dez, 12)
	FF_SetControl "Koordinaten zuweisen","breite_dez", Left(Latitude_dez, 12)
	Latitude_geo = decimal2grad (Latitude_dez, True)
	Longitude_geo = decimal2grad (Longitude_dez, False)
	FF_SetControl "Koordinaten zuweisen","breite_geo", Latitude_geo
	FF_SetControl "Koordinaten zuweisen","laenge_geo", Longitude_geo
	Erfolg_ja = 0
	Erfolg_nein = 0
	Bild = ""
	if AnzahlBilder = -2 Then						' Bild auf Arbeitsflche
		Bild = FF_GetImageName(-1)
		On Error Resume Next
		FF_LoadExif (Bild)
		if Err.Number = 2003 then					' Fehler 2003, wenn Bild noch ungespeichert ist
			Msgbox "Kein Bild im Arbeitsbereich geladen oder das Bild muss zunchst gespeichert werden.",64, "Koordinaten zuweisen"	
			Exit Sub
		End If
		On Error Goto 0
		Call Exif_schreiben
	Else											' Computeransicht oder Liste
		For i = 0 to AnzahlBilder -1
			Bild = ListeBilder(i)
			Call Exif_schreiben
		Next
	End if 
end Sub
	
Sub Exif_schreiben		
		FF_LoadExif (Bild)
		IF not FF_HasExifInFile (Bild) then		' Exif-Block fehlt noch
			FF_CreateExifInFile Bild
			FF_LoadExif (Bild)					' nach Erzeugung Exif-Block erneutes Laden notwendig
		End If
		FF_SetExifTag "Latitude", Latitude_geo
		FF_SetExifTag "Longitude", Longitude_geo
		FF_SaveExif Bild
		FF_SetExifDate Bild						' Exif-Datum als Dateidatum

		' ** Erfolgskontrolle **
		Erfolgsflag = false
		Do Until Erfolgsflag = true 
			If Not FF_HasExifInFile (Bild) Then Exit Do
			If Not FF_LoadExif (Bild) Then Exit Do
			If Len(FF_GetExifTag("Latitude")) = 0 Then Exit Do
			If Len(FF_GetExifTag("Longitude")) = 0 Then Exit Do
			' beim Test auf 4 Nachkommastellen runden, um Umrechungstoleranzen abzufangen, dazu zunchst Punkt durch Komma ersetzen
			REM msgbox round(replace(grad2decimal(FF_GetExifTag("Latitude")),".",","),4) & "     " & round(Replace(Latitude_dez,".",","),4)
			If round(replace(grad2decimal(FF_GetExifTag("Latitude")),".",","),4) <> round(Replace(Latitude_dez,".",","),4) Then Exit Do
			If round(Replace(grad2decimal(FF_GetExifTag("Longitude")),".",","),4) <> Round(Replace(Longitude_dez,".",","),4)Then Exit Do
			Erfolgsflag = true
		Loop
		If Erfolgsflag = true Then
			FF_RefreshDialog "Koordinaten zuweisen"
			FF_SetControl "Koordinaten zuweisen","ergeb_edit", "<" & nurDateiname(Bild) & "> wurde getaggt"
			If AnzahlBilder > 0 Then
				FF_SetControl "Koordinaten zuweisen","Fortschritt", (i+1) / AnzahlBilder * 100
			end If
			Erfolg_ja = Erfolg_ja + 1
		Else
			FF_SetControl "Koordinaten zuweisen","ergeb_edit", "Zuweisung der Koordinaten NICHT erfolgreich!"
			Erfolg_nein = Erfolg_nein + 1
		End If
		' **
	FF_SetControl "Koordinaten zuweisen","ergeb_edit","Bilder getaggt: " & Erfolg_ja & " - Bilder nicht getaggt: " &  Erfolg_nein
End Sub

'**************************************************
'* grad2decimal wandelt dezimal in  ' " um
'* erwartet die Dezimalkoordinate und 
'* True fr Breitengrad bzw. False fr Lngengrad
'**************************************************
Function decimal2grad (ByVal dezkoord, breite)
	Dim Richtung
	Dim Grad, Minuten, Sekunden
	if breite = true Then			' Breiten
		'westliche Breite und sdliche Lnge haben negativ Dezimalkoordinaten
		if InStr(dezkoord,"-") > 0 Then
			Richtung = "S"
		Else
			Richtung = "N"
		End If
	Else							' Lnge
		if InStr(dezkoord,"-") > 0 Then
			Richtung = "W"
		Else
			Richtung = "E"
		End If
	End If
	dezkoord = Replace(dezkoord,".",",")	' wegen Zahlenformat Punkt durch Komma ersetzen
	Grad = Abs(Fix(dezkoord))				' pos. Ganzzahl ermitteln
	Minuten = (Abs(dezkoord)-Grad)*60
	Sekunden = (Minuten - Fix(Minuten)) * 60
	Minuten = Fix(Minuten)
	decimal2grad = Richtung & " " & FormatNumber(Grad,2) & " " & FormatNumber(Minuten,2) & "' " &  FormatNumber(Round(Sekunden,2),2) & Chr(34)
	decimal2grad = Replace(decimal2grad,",",".")
End Function

'********************************************
'* grad2decimal wandelt  ' " in dezimal
'********************************************
Function grad2decimal(ByVal p_Str)
	dim l_Richtung
	dim l_Pos
	dim l_Wert

	if p_Str<>"" then
		p_Str=replace(p_Str,".",",",1)
		l_Richtung=left(p_Str,1)
		p_Str=ltrim(right(p_Str,len(p_Str)-1))
		l_Pos=instr(p_Str,"")
		'msgbox l_Wert
		l_Wert=1.0*(left(p_Str,l_Pos-1))
		p_Str=ltrim(right(p_Str,len(p_Str)-l_Pos))
		l_Pos=instr(p_Str,"'")
		l_Wert=l_Wert + (left(p_Str,l_Pos-1))/60
		p_Str=ltrim(right(p_Str,len(p_Str)-l_Pos))
		l_Pos=instr(p_Str,"""")
		l_Wert=l_Wert + (left(p_Str,l_Pos-1))/3600
		Select Case l_Richtung
			Case "s", "S", "w", "W"
				grad2decimal="-" & replace(FormatNumber(l_Wert,6),",",".",1)
			case Else
				grad2decimal=replace(FormatNumber(l_Wert,6),",",".",1)
		End Select
	else
		grad2decimal=""
	end if
End Function

Function nurDateiname (ByVal Pfad)
	nurDateiname = Right(Pfad, Len (Pfad) - InStrRev(Pfad, "\",-1, 1))
End Function

Function SearchRegAusdr(Zeichenfolge, Muster, GrossKleinBeachten)
' Vergleich einer Zeichenfolge mit einem Suchmuster, bei bereinstimmung
' wird True zurckgegeben, sonst False
    Dim regAusdr
    Set regAusdr = New RegExp
    regAusdr.Pattern = Muster
    regAusdr.IgnoreCase = GrossKleinBeachten    ' Bercksichtigung der Gro-/Kleinschreibung
    regAusdr.Global = True                      ' legt globales Anwenden fest
    If regAusdr.Test(Zeichenfolge) then
        SearchRegAusdr = True
    Else
        SearchRegAusdr = False
    End If
End Function

Function MidString (String, Suchstring1, Suchstring2)
' gibt den Teilstring zwischen Suchstring1 und Suchstring2 zurck
' Bsp.: MidString("123[456]789","[","]") ergibt "456"
' Bsp.: MidString("123#456#789","#","#") ergibt "456"
	If Instr(Instr(String,Suchstring1)+1, String,Suchstring2) > Instr(String,Suchstring1) Then
		MidString = Mid(String, Instr(String,Suchstring1)+1, Instr(Instr(String,Suchstring1)+1, String,Suchstring2)-Instr(String, Suchstring1)-1)
	End If
End Function

Sub Dialogaufbau
	'** Start Dialog Koordinaten zuweisen **
	FF_AddDialog "Koordinaten zuweisen",121,168
	FF_AddControl "Koordinaten zuweisen","Bilderquelle","GROUP",2,2,117,23
	FF_AddControl "Koordinaten zuweisen","Datenquelle","GROUP",2,102,67,43
	FF_AddControl "Koordinaten zuweisen","Breite (Latitude)","GROUP",2,51,117,23
	FF_AddControl "Koordinaten zuweisen","Lnge (Longitude)","GROUP",2,26,117,23
	FF_AddControl "Koordinaten zuweisen","laenge_dez","EDIT",5,35,40,10
	FF_SetControlStyle "Koordinaten zuweisen","laenge_dez",2048
	FF_AddControl "Koordinaten zuweisen","laenge_geo","EDIT",47,35,68,10
	FF_SetControlStyle "Koordinaten zuweisen","laenge_geo",2048
	FF_AddControl "Koordinaten zuweisen","breite_geo","EDIT",47,60,68,10
	FF_SetControlStyle "Koordinaten zuweisen","breite_geo",2048
	FF_AddControl "Koordinaten zuweisen","Koordinaten aus der Zwischenablage" & vbNewLine & "den Bildern zuweisen","BUTTON",2,78,117,18
	FF_AddControl "Koordinaten zuweisen","Schlieen","BUTTON",77,131,40,11
	FF_AddControl "Koordinaten zuweisen","?","BUTTON",78,104,12,11
	FF_AddControl "Koordinaten zuweisen","quelle1_bool","BOOL",5,111,8,8
	FF_SetControlStyle "Koordinaten zuweisen","quelle1_bool",16384
	FF_AddControl "Koordinaten zuweisen","GMapCatcher","STATIC",16,109,43,11
	FF_AddControl "Koordinaten zuweisen","ergeb_edit","EDIT",0,149,121,10
	FF_SetControlStyle "Koordinaten zuweisen","ergeb_edit",2048
	FF_AddControl "Koordinaten zuweisen","quelle2_bool","BOOL",5,122,8,8
	FF_SetControlStyle "Koordinaten zuweisen","quelle2_bool",16384
	FF_AddControl "Koordinaten zuweisen","Google Maps","STATIC",16,120,33,11
	FF_AddControl "Koordinaten zuweisen","->","BUTTON",55,120,10,10
	FF_AddControl "Koordinaten zuweisen",Version,"STATIC",94,104,15,11
	FF_AddControl "Koordinaten zuweisen","combo_quelle","COMBO",5,10,96,10
	FF_AddControl "Koordinaten zuweisen","|","STATIC",104,10,13,11
	FF_AddControl "Koordinaten zuweisen","Fortschritt","PROGRESS",0,159,121,9
	FF_AddControl "Koordinaten zuweisen","breite_dez","EDIT",5,60,40,10
	FF_SetControlStyle "Koordinaten zuweisen","breite_dez",2048
	FF_AddControl "Koordinaten zuweisen","quelle3_bool","BOOL",5,133,8,8
	FF_SetControlStyle "Koordinaten zuweisen","quelle3_bool",16384
	FF_AddControl "Koordinaten zuweisen","OpenStreetMap","STATIC",16,131,39,11
	FF_AddControl "Koordinaten zuweisen","|->","BUTTON",55,132,10,10
	'** End Dialog Koordinaten zuweisen **
	If FF_GetProfile(RegSchluessel,"GMapCatcher") <> "" Then 
		FF_SetControl "Koordinaten zuweisen","quelle1_bool", FF_GetProfile(RegSchluessel,"GMapCatcher")
		FF_SetControl "Koordinaten zuweisen","quelle2_bool", FF_GetProfile(RegSchluessel,"GoogleMaps")
		FF_SetControl "Koordinaten zuweisen","quelle3_bool", FF_GetProfile(RegSchluessel,"OSM")
	Else										' noch kein Registryeintrag
		FF_SetControl "Koordinaten zuweisen","quelle2_bool", "1"
	End If
	
	FF_SetControlTooltip "Koordinaten zuweisen", "->", "Ermittlung der Koordinaten ber die Seite" & vbNewLine & GoogleMapsSeite 
	FF_SetControlTooltip "Koordinaten zuweisen", "|->", "Ermittlung der Koordinaten ber die Seite" & vbNewLine & OSMSeite
	
		'FF_SetControl "Beschreib-fix","combo_quelle", " "
	FF_SetControl "Koordinaten zuweisen","combo_quelle", "Computer-Ansicht, alle Bilder"
	FF_SetControl "Koordinaten zuweisen","combo_quelle", "Computer-Ansicht, markierte Bilder"
	FF_SetControl "Koordinaten zuweisen","combo_quelle", "Bilderliste, alle Bilder"
	FF_SetControl "Koordinaten zuweisen","combo_quelle", "Bilderliste, markierte Bilder"
	FF_SetControl "Koordinaten zuweisen","combo_quelle", "geladenes Bild"
	FF_SetControl "Koordinaten zuweisen","combo_quelle", "Computer-Ansicht, markierte Bilder" ' Vorbelegung
End Sub